# coding: utf-8

"""
    Social Toolkit

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class GenerationResponseSchema(BaseModel):
    """
    GenerationResponseSchema
    """ # noqa: E501
    brand_id: StrictStr
    created_at: datetime
    generation_id: StrictStr
    output_type: StrictStr
    prompt: StrictStr
    result: Dict[str, Any]
    status: StrictStr
    tenant_id: StrictStr
    updated_at: datetime
    use_source_context: StrictBool
    worker_id: StrictStr
    __properties: ClassVar[List[str]] = ["brand_id", "created_at", "generation_id", "output_type", "prompt", "result", "status", "tenant_id", "updated_at", "use_source_context", "worker_id"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['NOT_STARTED', 'PROCESSING', 'COMPLETED', 'FAILED']):
            raise ValueError("must be one of enum values ('NOT_STARTED', 'PROCESSING', 'COMPLETED', 'FAILED')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GenerationResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GenerationResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "brand_id": obj.get("brand_id"),
            "created_at": obj.get("created_at"),
            "generation_id": obj.get("generation_id"),
            "output_type": obj.get("output_type"),
            "prompt": obj.get("prompt"),
            "result": obj.get("result"),
            "status": obj.get("status"),
            "tenant_id": obj.get("tenant_id"),
            "updated_at": obj.get("updated_at"),
            "use_source_context": obj.get("use_source_context") if obj.get("use_source_context") is not None else True,
            "worker_id": obj.get("worker_id")
        })
        return _obj


